<?php
//nulled by mingyuan
//nulled by 2018-07-28

namespace MxiDev\emailverify;
if( !class_exists("Apps") ) 
{
	class Apps 
	{
		public $vars = array( );
		public $modulename = "emailverify";
		public $name = "Email address verification";
		public $description = "一款可以生成验证码并发送，强制验证用户邮箱的插件";
		public $version = "1.0";
		public $author = "<a href=\"https://mxidev.com\" target=\"_blank\">MxiDev</a>";
		public function __construct($vars = array( )) 
		{
			$this->vars = $vars;
		}
		public function config() 
		{
			try 
			{
				$configarray = array( "name" => $this->name, "description" => $this->description, "version" => $this->version, "author" => $this->author, "fields" => array( "licensekey" => array( "FriendlyName" => "许可密钥", "Type" => "text", "Size" => "40", "Description" => "请在此输入许可密钥" ), "codeDigit" => array( "FriendlyName" => "随机码位数", "Type" => "text", "Size" => "5", "Default" => "6", "Description" => "4-9位之间，默认6位数" ), "verfyWithoutBuy" => array( "FriendlyName" => "购买过程不提示验证邮箱", "Type" => "dropdown", "Options" => array( "关闭", "启用" ), "Description" => "启用后用户在未验证邮箱的情况下允许购买产品/服务，不会打断用户购买流程", "Default" => "1" ), "verfyWhenAdmin" => array( "FriendlyName" => "以管理员身份登录时不显示验证页面", "Type" => "dropdown", "Options" => array( "关闭", "启用" ), "Description" => "启用后在后台使用管理员身份查看客户界面时不强制跳出验证页面", "Default" => "0" ), "sign" => array( "FriendlyName" => "安全效验码", "Type" => "text", "Size" => "20", "Default" => Tools::getRand(10), "Description" => "自动生成10位随机码" ) ) );
			}
			catch( \Exception $e ) 
			{
				$configarray = array( "name" => $this->name, "description" => $this->description, "version" => $this->version, "author" => $this->author, "fields" => array( "licensekey" => array( "FriendlyName" => "许可密钥", "Type" => "text", "Size" => "25", "Description" => "请在此输入许可密钥" ), "sign" => array( "FriendlyName" => "安全效验码", "Type" => "text", "Size" => "20", "Default" => Tools::getRand(10), "Description" => "自动生成10位随机码" ), "error" => array( "FriendlyName" => "出现错误！", "Type" => "yesno", "Size" => "25", "Description" => "<strong>错误信息：</strong>" . $e->getMessage() ) ) );
			}
			return $configarray;
		}
		public function activate() 
		{
			try 
			{
				Schema::dropIfExists("mod_emailverify");
				Schema::create("mod_emailverify", function(\Illuminate\Database\Schema\Blueprint $table) 
				{
					$table->increments("id");
					$table->integer("uid");
					$table->string("email");
					$table->integer("rand_code");
					$table->timestamps();
				}
				);
				return array( "status" => "success", "description" => "模块激活成功，请点击配置进行设置" );
			}
			catch( \Exception $e ) 
			{
				return array( "status" => "error", "description" => "模块激活失败: " . $e->getMessage() );
			}
		}
		public function deactivate() 
		{
			try 
			{
				$templates_c = Tools::getTemplatesC();
				Tools::delFile($templates_c . "/emailverify_License.php");
				Schema::dropIfExists("mod_emailverify");
				\Illuminate\Database\Capsule\Manager::table("tbladdonmodules")->where("module", "emailverify")->delete();
				return array( "status" => "success", "description" => "模块卸载成功" );
			}
			catch( \Exception $e ) 
			{
				return array( "status" => "error", "description" => "无法删除数据: " . $e->getMessage() );
			}
		}
		public function clientarea() 
		{
			if( $_POST ) 
			{
				return ClientArea::verify($this->vars);
			}
			return ClientArea::client($this->vars);
		}
		public function hooks() 
		{
			add_hook("DailyCronJob", 1, function($vars) 
			{
				try 
				{
					$delete = DB::where("updated_at", "<=", date("Y-m-d H:i:s", strtotime("-1 days")))->delete();
				}
				catch( \Exception $e ) 
				{
					logActivity("emailverify: 删除过期的验证码时出错 " . $e->getMessage());
				}
			}
			);
			add_hook("EmailPreSend", 1, function($vars) 
			{
				try 
				{
					if( $vars["messagename"] == "Client Email Address Verification" ) 
					{
						$codeDigit = Tools::getCodeDigit();
						$randCode = Tools::getRandNumber($codeDigit);
						$uid = (int) $_SESSION["uid"];
						if( empty($uid) ) 
						{
							$uid = (int) $vars["relid"];
						}
						$userEmail = \Illuminate\Database\Capsule\Manager::table("tblclients")->where("id", $uid)->first()->email;
						$check = DB::where("uid", $uid)->where("email", $userEmail)->first();
						if( empty($check) ) 
						{
							$db = new DB();
							$db->uid = $uid;
							$db->email = $userEmail;
							$db->rand_code = $randCode;
							$db->save();
						}
						else 
						{
							DB::where("uid", $uid)->where("email", $userEmail)->update(array( "rand_code" => $randCode ));
						}
						$emailvars = array( );
						$emailvars["random_code"] = $randCode;
						return $emailvars;
					}
				}
				catch( \Exception $e ) 
				{
					logActivity("emailverify: 发送验证邮件时出错 " . $e->getMessage());
				}
			}
			);
			add_hook("ClientAreaHeadOutput", 1, function($vars) 
			{
				try 
				{
					$verfyWhenAdmin = \Illuminate\Database\Capsule\Manager::table("tbladdonmodules")->where("module", "emailverify")->where("setting", "verfyWhenAdmin")->first()->value;
					if( empty($_SESSION["adminid"]) || $verfyWhenAdmin != "1" ) 
					{
						$viewFileName = end(explode("/", $_SERVER["REQUEST_URI"]));
						$verfyWithoutBuy = \Illuminate\Database\Capsule\Manager::table("tbladdonmodules")->where("module", "emailverify")->where("setting", "verfyWithoutBuy")->first()->value;
						$allowURL = array( "index.php", "submitticket.php", "viewinvoice.php" );
						$disAllowURL = array( "downloads.php", "affiliates.php", "announcements.php", "knowledgebase.php", "clientarea.php" );
						if( !Tools::checkURL($allowURL, $viewFileName) && $viewFileName != "clientarea.php?action=details" ) 
						{
							if( $verfyWithoutBuy != "0" ) 
							{
								if( Tools::checkURL($disAllowURL, $viewFileName) ) 
								{
									$uid = (int) $_SESSION["uid"];
									if( !empty($uid) ) 
									{
										$getVerifyResult = \Illuminate\Database\Capsule\Manager::table("tblclients")->where("id", $uid)->first()->email_verified;
										if( !$getVerifyResult == "1" ) 
										{
											exit( header("location:" . Tools::getSystemURL() . "index.php?m=emailverify") );
										}
									}
								}
							}
							else 
							{
								$uid = (int) $_SESSION["uid"];
								if( !empty($uid) ) 
								{
									$getVerifyResult = \Illuminate\Database\Capsule\Manager::table("tblclients")->where("id", $uid)->first()->email_verified;
									if( !$getVerifyResult == "1" ) 
									{
										exit( header("location:" . Tools::getSystemURL() . "index.php?m=emailverify") );
									}
								}
							}
						}
					}
				}
				catch( \Exception $e ) 
				{
					logActivity("emailverify: 出现错误 " . $e->getMessage());
				}
			}
			);
		}
	}
}
if( !class_exists("License") ) 
{
	class License 
	{
		public function doCheck($force = false) 
		{
			$templates_c = (string) $GLOBALS["templates_compiledir"];
			if( !is_readable($templates_c) || !is_writeable($templates_c) ) 
			{
				throw new \Exception("模板缓存目录 [ " . $templates_c . " ] 无法读取或写入，请检查目录权限");
			}

		}
		public function getLicense($licensekey, $localkey = "") 
		{
		}
		public function checkLicense($results = "") 
		{
			$templates_c = (string) $GLOBALS["templates_compiledir"];
			if( !is_readable($templates_c) || !is_writeable($templates_c) ) 
			{
				throw new \Exception("模板缓存目录 [ " . $templates_c . " ] 无法读取或写入，请检查目录权限");
			}

			return "success";
		}
	}
}
?>